clc;
p=180;
i=3200;
Sn=20e3;%rated apparent power,kVA
Vn=200;%peak phase voltage value
Vdc=500;%dc voltage value
In=sqrt(2)*Sn/(3*Vn/sqrt(2));%peak phase current value
Vbase=Vn;
Ibase=In;
Vdcbase=2*Vbase;
kdcpu=Vdc/Vdcbase;
fbase=50;%base frequency
zbase=Vbase/(Ibase);%base impedance
wbase=2*pi*fbase;
Lbase=zbase/wbase;
Rbase=zbase;
Cbase= 1/(wbase*zbase);
C=990e-6;
h=1;
w0=wbase;
Ts=200e-6;%2e-4;
Rf=0.5;
Lf=5e-3;
Rfpu=Rf/Rbase;%change to pu 
Lfpu=Lf/Lbase;%change to pu
Cpu=C/Cbase;
kp=1;%proportional gain for current controller
ki=300;%resonant gain for current controller
kT=ki*Ts;
Ch=((h*w0)^2)-(((h*w0)^4*Ts^2)/12)+(((h*w0)^6*Ts^4)/360);
Ch
rho=exp(Rfpu*Ts*wbase/Lfpu);
rho
Gfz=tf([0 (rho-1)/Rfpu],[rho -1],Ts);
Gdz=tf([0 1],[1 0],Ts);
Gplz=Gdz*Gfz; % plant function
Gplz
im=(rho*sin(2*h*w0*Ts))-sin(h*w0*Ts);
re=(rho*cos(2*h*w0*Ts))-cos(h*w0*Ts);
angleG=-atan(im/re);
cc=-2*(1-(Ch*Ts*Ts*0.5));
cc
phi_h=-angleG;
phi_h
cos(phi_h)
cos((h*w0*Ts)+phi_h)
R=tf([cos((h*w0*Ts)+phi_h) -cos(phi_h)],[1 cc 1],Ts);
Gcfb=kp+(ki*Ts*R); % PR controller function with delay compensation
Gcfb
q=feedback(Gcfb*Gplz,1);%closed loop representation of current controller
Gvpcz=tf([0 Ts*wbase/Cpu],[1 -1],Ts);%zero order hold
Gvplz=Gvpcz*q;
kP=1;
kI=200;%25;%15,10;
kTv=kI*Ts;
Chv=((h*w0)^2)-(((h*w0)^4*Ts^2)/12)+(((h*w0)^6*Ts^4)/360);
Chv
ccv=-2*(1-(Chv*Ts*Ts*0.5));
ccv
re_num=(0.008162*cos(2*w0*Ts))-(0.01622*cos(w0*Ts))+0.008058;
im_num=(0.008162*sin(2*w0*Ts))-(0.01622*sin(w0*Ts));
re_den=(1.02*cos(5*w0*Ts))-(4.057*cos(4*w0*Ts))+(6.174*cos(3*w0*Ts))-(4.378*cos(2*w0*Ts))+(1.361*cos(w0*Ts))-0.1197;
im_den=(1.02*sin(5*w0*Ts))-(4.057*sin(4*w0*Ts))+(6.174*sin(3*w0*Ts))-(4.378*sin(2*w0*Ts))+(1.361*sin(w0*Ts));
anglev=atan(im_num/re_num)-atan(im_den/re_den);
phi_hv=-anglev;
cos(phi_hv)
cos((h*w0*Ts)+phi_hv)
Rv=tf([cos((h*w0*Ts)+phi_hv) -cos(phi_hv)],[1 ccv 1],Ts);
Gvcfb=kP+(kI*Ts*Rv); % PR controller function with delay compensation
Gvcfb
dbode(Gcfb,{10,1e6},Ts);
grid;
title('individual characteristics of Gcfb: ');
figure;
dbode(Gvcfb,{10,1e6},Ts);
grid;
title('individual characteristics of Gvcfb: ');
figure;
dbode(Gcfb*Gplz,{10,1e6},Ts);
grid;
title('stability analysis with Gcfb: ');
figure;
dbode(Gvcfb*Gvplz,{10,1e6},Ts);
grid;
title('stability analysis with Gvcfb: ');
figure;
dbode(q,{100,1000},Ts);
grid;
title('closed loop tracking for Gcfb and plant: ');
figure;
qv=feedback(Gvcfb*Gvplz,1);
dbode(qv,{100,1000},Ts);
grid;
title('closed loop tracking for Gvcfb and plant: ');
figure;
nyquist(Gcfb*Gplz);
grid;
title('nyquist plot for Gcfb and Gplz: ');
figure;
nyquist(Gvcfb*Gvplz);
grid;
title('nyquist plot for Gvcfb and Gvplz: ');
figure;

